<template>
  <form
    class="fr-container--fluid"
    @submit.prevent="onSaveInterview"
  >
    <div class="fr-grid-row fr-grid-row--gutters form-grid">
      <AtomCheckbox
        class="fr-col-12"
        label="1er entretien"
        name="first_follow_up"
        :model-value="interview?.first_follow_up || false"
      />

      <AtomInput
        name="date"
        label="Date"
        type="date"
        :value="interview ? interview.date : TODAY"
        required
      />

      <AtomInput
        v-if="isMinistryAgent"
        name="numero_pegase"
        label="Numéro Pégase"
        :value="interview ? interview.numero_pegase : ''"
      />

      <AtomSelect
        v-model="interviewType"
        name="type"
        label="Type d'entretien"
        :options="withEmptyValue(INTERVIEW_TYPE_OPTIONS)"
        required
      />

      <AtomSelect
        v-if="isMinistryAgent"
        name="ministre"
        label="Ministre"
        :options="withEmptyValue(MINISTRE_OPTIONS)"
        :model-value="interview ? interview.ministre : ''"
      />

      <AtomInput
        v-if="interviewType === OUTSIDE_INTERVIEW_TYPE_VALUE"
        class="fr-col-12 fr-col-lg-8"
        name="place"
        label="Lieu de rendez-vous"
        :value="interview ? interview.place : ''"
      />

      <AtomInput
        v-if="interviewType === WITH_THIRD_PERSON_INTERVIEW_TYPE_VALUE"
        name="third_person_name"
        label="Nom du tiers"
        :value="interview ? interview.third_person_name : ''"
      />

      <AtomSearchableSelect
        label="Objet de l'entretien"
        name="follow_up_types"
        :options="followUpTypeOptions"
        :value="initialFollowUpTypeIds"
        required
        hint
        multiple
      >
        <template #hint>
          <span class="fr-icon-information-line fr-fi--sm">
            <NuxtLink
              v-if="canEditOrganisation"
              :to="Routes.OrganisationEdit"
              target="_self"
            >
              Personnaliser les objets des entretiens de ma structure.
            </NuxtLink>
            <template v-else>
              Les responsables de votre structure peuvent personnaliser ces
              objets des entretiens.
            </template>
          </span>
        </template>
      </AtomSearchableSelect>

      <AtomSearchableSelect
        label="Organisme prescripteur"
        name="organisme_prescripteur"
        :options="prescribingOrganisationOptions"
        :value="
          interview && interview.organisme_prescripteur
            ? String(interview.organisme_prescripteur)
            : ''
        "
        :can-create-new-option="canCreateOrganisme"
      />

      <AtomSelect
        v-model="status"
        name="status"
        label="Statut"
        :options="INTERVIEW_STATUS_OPTIONS"
        required
      />

      <AtomInput
        name="due_date"
        label="Date d'échéance"
        type="date"
        :value="interview ? interview.due_date : ''"
      />

      <AtomTextarea
        class="fr-col-12 large-textarea"
        name="synthesis"
        label="Compte rendu"
        :value="interview ? interview.synthesis : ''"
      />

      <AtomTextarea
        v-if="canSetPrivateSynthesis"
        class="fr-col-12"
        name="private_synthesis"
        label="Compte rendu privé"
        :value="
          interview ? interview.private_synthesis[0]?.private_synthesis : ''
        "
        label-icon="fr-icon-lock-line"
        hint
      >
        <template #hint>
          Le compte rendu privé est uniquement visible et modifiable par l'agent
          qui crée la synthèse d'entretien.<br />{{ SENSITIVE_DATA_HINT }}
        </template>
      </AtomTextarea>

      <fieldset
        class="fr-fieldset fr-col-12"
        aria-labelledby="interview-actions-entreprises-legend"
      >
        <legend
          id="interview-actions-entreprises-legend"
          class="fr-fieldset__legend fr-h6"
        >
          Actions entreprises
        </legend>

        <div class="fr-fieldset__element fr-mb-0">
          <fieldset
            class="fr-fieldset fr-mb-0"
            aria-labelledby="interview-reoriente-apres-entretien-legend"
          >
            <legend
              id="interview-reoriente-apres-entretien-legend"
              hidden
            >
              Réorienté après l'entretien
            </legend>

            <div class="fr-fieldset__element fr-fieldset__element--inline">
              <AtomCheckbox
                v-model="redirected"
                name="redirected"
                label="Réorienté après l'entretien"
              />
            </div>
            <div class="fr-fieldset__element fr-fieldset__element--inline">
              <AtomInput
                v-if="redirected"
                name="organisation_name"
                label="Nom de l'organisme"
                :value="interview ? interview.organisation_name : ''"
              />
            </div>
          </fieldset>
        </div>

        <div class="fr-fieldset__element fr-fieldset__element--inline">
          <AtomCheckbox
            name="help_request"
            label="Instruction de demande d'aide"
            :model-value="interview && interview.help_request"
          />
        </div>

        <template v-if="isMinistryAgent">
          <div class="fr-fieldset__element fr-fieldset__element--inline">
            <AtomCheckbox
              name="classified"
              label="Classé"
              :model-value="interview && interview.classified"
            />
          </div>

          <div class="fr-fieldset__element fr-fieldset__element--inline">
            <AtomCheckbox
              name="forwarded_to_justice"
              label="Transmis à la justice"
              :model-value="interview && interview.forwarded_to_justice"
            />
          </div>

          <div class="fr-fieldset__element fr-mb-0">
            <fieldset
              class="fr-fieldset fr-mb-0"
              aria-labelledby="interview-interventions-legend"
            >
              <legend
                id="interview-interventions-legend"
                class="fr-fieldset__legend"
              >
                Interventions
              </legend>
              <div
                v-for="[value, label] in INTERVIEW_INTERVENTION_OPTIONS"
                :key="value"
                class="fr-fieldset__element fr-fieldset__element--inline"
              >
                <AtomCheckbox
                  :name="value"
                  :label="label"
                  :model-value="
                    interview && interview.interventions?.includes(value)
                  "
                />
              </div>
            </fieldset>
          </div>

          <div class="fr-fieldset__element fr-mb-0">
            <fieldset
              class="fr-fieldset fr-mb-0"
              aria-labelledby="interview-signalements-legend"
            >
              <legend
                id="interview-signalements-legend"
                class="fr-fieldset__legend"
              >
                Signalements
              </legend>
              <div
                v-for="[value, label] in INTERVIEW_SIGNALEMENT_OPTIONS"
                :key="value"
                class="fr-fieldset__element fr-fieldset__element--inline"
              >
                <AtomCheckbox
                  :name="value"
                  :label="label"
                  :model-value="
                    interview && interview.signalements?.includes(value)
                  "
                />
              </div>
            </fieldset>
          </div>
        </template>
      </fieldset>
    </div>

    <BeneficiaryDocumentsSelect
      class="fr-mb-4w"
      :beneficiary-id="beneficiaryId"
      name="documents"
      label="Documents"
      :value="initialDocumentIds"
      :help-request="false"
    />

    <ul
      class="fr-btns-group fr-btns-group--inline fr-btns-group--lg fr-btns-group--right"
    >
      <li>
        <button
          class="fr-btn submit-btn"
          type="submit"
          :submitting="isSubmitting"
          :disabled="isSubmitting"
        >
          Enregistrer
        </button>
      </li>
    </ul>
  </form>
</template>

<script setup>
  import {
    checkboxValuesToBoolean,
    toOptions,
    prepareM2MRelation,
    newOptionToLabel,
    withEmptyValue
  } from '~/utils'
  import { SENSITIVE_DATA_HINT, NEW_OPTION_PREFIX } from '~/utils/constants'
  import {
    DONE_INTERVIEW_STATUS_VALUE,
    INTERVIEW_INTERVENTION_OPTIONS,
    INTERVIEW_SIGNALEMENT_OPTIONS,
    INTERVIEW_STATUS_OPTIONS,
    INTERVIEW_TYPE_OPTIONS,
    OUTSIDE_INTERVIEW_TYPE_VALUE,
    WITH_THIRD_PERSON_INTERVIEW_TYPE_VALUE
  } from '~/utils/constants/interview'
  import { useAuthStore } from '~/store/auth'
  import { MINISTRE_OPTIONS } from '~~/utils/constants/ministry'
  import { usePermissionsStore } from '~/store/permissions'
  import { Routes } from '~/utils/routing/routes'

  const { $dayjs } = useNuxtApp()
  const authStore = useAuthStore()
  const permissionsStore = usePermissionsStore()

  const TODAY = $dayjs().format('YYYY-MM-DD')

  const props = defineProps({
    isSubmitting: { type: Boolean, required: true },
    followUpTypes: { type: Array, required: true },
    prescribingOrganisations: { type: Array, required: true },
    interview: { type: Object, default: null },
    beneficiaryId: { type: String, required: true }
  })

  const emit = defineEmits(['saveInterview'])

  const status = ref(props.interview?.status || DONE_INTERVIEW_STATUS_VALUE)
  const interviewType = ref(props.interview?.type)
  const redirected = ref(props.interview?.redirected)

  const followUpTypeOptions = computed(() =>
    toOptions(props.followUpTypes, 'id', 'name')
  )

  const initialFollowUpTypeIds = computed(
    () => props.interview?.follow_up_types.map(f => f.follow_up_types_id) || []
  )

  const prescribingOrganisationOptions = computed(() => {
    const prescribingOrganisationsWithStringId =
      props.prescribingOrganisations.map(({ id, ...rest }) => ({
        id: String(id),
        ...rest
      }))
    return toOptions(prescribingOrganisationsWithStringId, 'id', 'name')
  })

  const isMinistryAgent = computed(() => authStore.isMinistryAgent)

  const canSetPrivateSynthesis = computed(() =>
    permissionsStore.canSetPrivateSynthesis(props.interview)
  )

  const canEditOrganisation = computed(
    () => permissionsStore.canEditOrganisation
  )

  const initialDocumentIds = computed(
    () => props.interview?.documents.map(d => d.directus_file) || []
  )

  const canCreateOrganisme = computed(() => permissionsStore.canCreateOrganisme)

  function onSaveInterview({ target }) {
    const interview = prepareInterview(target)
    emit('saveInterview', interview)
  }

  function prepareInterview(form) {
    const CHECKBOX_KEYS = ['redirected', 'help_request', 'first_follow_up']

    if (isMinistryAgent.value) {
      CHECKBOX_KEYS.push(
        'classified',
        'forwarded_to_justice',
        ...INTERVIEW_INTERVENTION_OPTIONS.keys(),
        ...INTERVIEW_SIGNALEMENT_OPTIONS.keys()
      )
    }

    const interview = checkboxValuesToBoolean(
      Object.fromEntries(new FormData(form)),
      CHECKBOX_KEYS
    )

    // Set empty fields as null
    Object.keys(interview).forEach(key => {
      if (!interview[key]) interview[key] = null
    })

    if (isMinistryAgent.value) {
      interview.interventions = []
      for (const key of INTERVIEW_INTERVENTION_OPTIONS.keys()) {
        if (interview[key]) interview.interventions.push(key)
        delete interview[key]
      }
      interview.signalements = []
      for (const key of INTERVIEW_SIGNALEMENT_OPTIONS.keys()) {
        if (interview[key]) interview.signalements.push(key)
        delete interview[key]
      }
    }

    if (canSetPrivateSynthesis.value) {
      interview.private_synthesis = [
        { private_synthesis: interview.private_synthesis }
      ]

      if (props.interview?.private_synthesis.length) {
        interview.private_synthesis[0].id =
          props.interview.private_synthesis[0].id
      }
    }

    interview.follow_up_types = prepareM2MRelation(
      props.interview?.follow_up_types,
      interview.follow_up_types.split(','),
      'follow_up_types_id'
    )

    interview.beneficiary = { id: props.beneficiaryId }

    interview.documents = prepareM2MRelation(
      props.interview?.documents,
      interview.documents?.split(',') || [],
      'directus_file'
    )

    if (interview.organisme_prescripteur?.startsWith(NEW_OPTION_PREFIX)) {
      interview.organisme_prescripteur = {
        name: newOptionToLabel(interview.organisme_prescripteur),
        organisation: authStore.userOrganisationId
      }
    }

    return interview
  }
</script>
